#!/usr/bin/python3

import serial
import json
import pprint

try:
  ser = serial.Serial('/dev/ttyUSB0', 1200)
except:
  print("/dev/ttyUSB0 not in")

Kisnabled=False

while True:
  data = ser.readline()
  if data:
    #print(data)
    if (Kisnabled==True and data):
      print(data)
      try:
        toKismet=json.dumps(data.decode("utf-8").rstrip())   #was ascii
        print("========")
        aprs=json.loads(data.decode("utf-8").rstrip())
        print("-------------------")
        if (aprs['data'][0] == ";"):
          aprs['object']=aprs['data'][1:10]
          aprs['ztime']=aprs['data'][11:18]
          aprs['lat']=aprs['data'][18:26]
          aprs['long']=aprs['data'][28:36]

        if (aprs['data'][0] == "!"):
          aprs['object']=aprs['data'][20:25]
          aprs['ztime']=""
          aprs['lat']=aprs['data'][1:8]
          aprs['long']=aprs['data'][10:18]

        if (aprs['data'][0] == "}"):
          tmp=aprs['data'].split(">")
          aprs['object']=tmp[1:]
          tmp2=tmp[1].split(":")
          if(tmp2[1][0]=="/"):
            aprs['ztime']=tmp[1][23:30]
            aprs['lat']=tmp[1][30:38]
            aprs['long']=tmp[1][40:48]

        if (aprs['data'][0] == "="):
          aprs['object']=aprs['data'][20:]
          aprs['ztime']=""
          aprs['lat']=aprs['data'][1:9]
          aprs['long']=aprs['data'][10:19]

        pprint.pprint(aprs)
        print("========")
      except:
        print("========")
        print("FAIL:")
        print(data.decode("utf-8").rstrip())
        print("========")
    if (data==b'APRS2Kismet\r\n'):
      Kisnabled=True
      print("Enabling")
